import 'jsuites/dist/jsuites.js'
import 'jspreadsheet-ce/dist/index.js'
import {PolymerElement} from '@polymer/polymer/polymer-element.js';
import {ElementMixin} from '@vaadin/component-base/src/element-mixin.js';

class Spreadsheet extends ElementMixin(PolymerElement) {
    static get is() {
        return 'demo-jspreadsheet';
    }

    static get properties() {
        return {

/*
            columns: {
                type: Object,
                value: ['One', 'Two', 'Three'],
                observer: '_onColumnsChange'
            },

/*
            data: {
                type: String[][],
                value: [['1', '2', '3'], ['4', '5', '6']]
                notify: true,
                observer: '_onDataChange'
            },

            /** @private */
            _spreadsheet: {
                type: Object
            }
        }
    }

    ready() {
        super.ready();

        // const sliderElement = this.shadowRoot.querySelector('[part="slider"]');
        // this._slider = $(sliderElement);
        this._spreadsheet = $(this);
        this._spreadsheet.jspreadsheet({
            allowInsertRow: false,
            allowDeleteRow: false,
            allowInsertColumn: false,
            allowDeleteColumn: false,
            allowRenameColumn: false,
            rowDrag: false,
            columnDrag: false,
            columnSorting: false,
            includeHeadersOnDownload: true,
            minDimensions: [25, 25],
            //csv: 'https://people.sc.fsu.edu/~jburkardt/data/csv/addresses.csv',
            columns: [
                        { title:'Model', width:'30px' },
                        { title:'Price', width:'20px' },
                        { title:'Model', width:'20px' }
                    ],
            data: [
                        ['Mazda', 2001, 2000],
                        ['Peugeot', 2010, 5000],
                        ['Honda Fit', 2009, 3000],
                        ['Honda CRV', 2010, 6000],
                    ],
            /*
            columns: this.columns,
            data: this.data,
            change: function (event, ui) {
                if (this.data === ui.data) {
                    return;
                }
                this.data = ui.data;
                const spreadsheetChangeEvent = new CustomEvent('custom-spreadsheet-changed', {detail: {data: ui.data}});
                this.dispatchEvent(spreadsheetChangeEvent);
            }
            */
        });
    }

    /**
     * @protected
     *
    _onDataChange(data) {
        if (this._spreadsheet === undefined) {
            return;
        }

        this._spreadsheet.spreadsheet("data", data);
    }


    /**
     * @protected
     *
    _onColumnsChange(value) {
        if (this._spreadsheet === undefined) {
            return;
        }

        this._spreadsheet.jspreadsheet("option", "columns", value);
    }
    */

}

customElements.define(Spreadsheet.is, Spreadsheet);
export {Spreadsheet};