package com.company.tryspreadsheet.view.sandbox;

import com.company.tryspreadsheet.component.spreadsheet.Spreadsheet;
import com.company.tryspreadsheet.view.main.MainView;
import com.vaadin.flow.component.ClickEvent;
import com.vaadin.flow.router.Route;
import com.vaadin.flow.server.auth.AnonymousAllowed;
import io.jmix.flowui.Notifications;
import io.jmix.flowui.kit.component.button.JmixButton;
import io.jmix.flowui.view.StandardView;
import io.jmix.flowui.view.Subscribe;
import io.jmix.flowui.view.ViewController;
import io.jmix.flowui.view.ViewDescriptor;
import org.springframework.beans.factory.annotation.Autowired;

@Route(value = "sandbox-view", layout = MainView.class)
@ViewController("SandboxView")
@ViewDescriptor("sandbox-view.xml")
@AnonymousAllowed
public class SandboxView extends StandardView {

    @Autowired
    private Notifications notifications;

    private Spreadsheet spreadsheet;

    @Subscribe
    public void onInit(final InitEvent event) {
        spreadsheet = new Spreadsheet();
        spreadsheet.setWidth("250px");
        spreadsheet.setHeight("250px");
        getContent().addComponentAtIndex(0, spreadsheet);
    }

    @Subscribe("setValueBtn")
    public void onSetValueBtnClick(final ClickEvent<JmixButton> event) {
        //spreadsheet.setValue(10);
    }

    @Subscribe("showValueBtn")
    public void onShowValueBtnClick(final ClickEvent<JmixButton> event) {
        //notifications.show("Value: " + spreadsheet.getValue());
    }

}